#include <iostream>
#include <fstream>
#include <string>

#include <cstdlib>
#include <ctime>

#include <boost/thread.hpp>
#include <boost/bind.hpp>

using namespace std;
using namespace boost;

void writeMsg(string str)
{
  time_t clock;
  for (int i = 0; i < 100; i++){
    time(&clock);
    cout << str << ": " << ctime(&clock);
    for(int j = 0; j < 10000; j++){
      for(int k = 0; k < 10000; k++){
	int a = j * k;
      }
    }
  }
}
    

int main()
{
  string thName1="Thread 1";
  string thName2="Thread 2";
  thread thWriteMsg1(bind(&writeMsg, thName1));
  thread thWriteMsg2(bind(&writeMsg, thName2));

  time_t clock;

  for (int i = 0; i < 100; i++){
    time(&clock);
    cout << "MAIN: " << ctime(&clock);
    for(int j = 0; j < 10000; j++){
      for(int k = 0; k < 10000; k++){
	int a = j * k;
      }
    }
  }

  thWriteMsg1.join();
  thWriteMsg2.join();

  return EXIT_SUCCESS;
}
